%esempio di filtro passa basso 

clc  %pulizia command window
clear all % pulizia workspace
close all  %chiusura figure

%definizione asse temporale
tmin=0; %istante iniziale (in [s])
tmax=10; %istante finale (in [s])
dt=0.001; %passo di cmapionamento (N.B. questa quantità è 
%legata alla frequenza del segnale da considerare)
t=tmin:dt:tmax; %asse temporale

%definizione segnale
f0=1; %frequenza del primo segnale (in [Hz])
f1=2; %frequenza del secondo segnale(in [Hz])
x=cos(2*pi*f0*t); % prima sinusoide (segnale utile)
x1=cos(2*pi*f1*t); %seconda sinusoide (disturbo)
x2=x+x1; %segnale somma (utile+disturbo)
figure,plot(t,x2)% visualizzazione del segnale somma nel dominio del tempo

% trasformata di fourier sel segnale somma
fmax=1/dt; % frequenza massima rappresentabile 
%(è sempre il reciproco del passo di campionamento)
f=linspace(-fmax/2,fmax/2,length(t)); %asse frequenziale 
%(scelto delle stesse dimensioni dei segnali da rappresentare)
X2=fftshift(fft(x2)); %trasformata di fourier (fft) e shift in frequenza (fftshift)
%fftshift serve a portare la frequenza "0" al centro dell'asse frequenziale
figure,plot(f,abs(X2)) %visualizzazione dello spettro del segnale
%da notare che, essendo lo spettro complesso, posso valutarlo in termini di
%modulo (abs) e fase (angle) oppure come parte reale (real) e immaginaria(imag)

% definizione filtro in frequenza
H=zeros(1,length(t)); %inizializzazione di un vettore
H(abs(f)<1.5)=1; %filtro passa basso con frequenza di taglio pari ad 1.5 Hz
% (si sceglie una frequenza di taglio tale da preservare il segnale utile
% eliminando i disturbi)
figure,plot(f,H) %visualizzazione del filtro 

%applicazione del filtro
Xf=X2.*H; %si ricorda che la presenza del "." 
%serve a dire il codice di effettuare l'operazione di prodotto "elemento per elemento"
figure,plot(f,abs(Xf)) %visualizzazione del segnale filtrato nel dominio frequenziale
%verificare che il disturbo sia stato eliminato correttamente

%antitrasformata di fourier
xf=ifft(ifftshift(Xf)); %trasformata di fourier del segnale filtrato
% da notare l'ordine inverso dei comandi di shift e antitrasformata
% rispetto alla trasformata diretta
figure,plot(t,xf) %visualizzazione del segnale filtrato nel dominio del tempo

